<template>
  <bgBox :tabChange="tabChange" class="bgBox" :tabIndex="0">
    <histogram
        style="position: absolute; left: 20px; top: 98px"
        class="animated fadeInLeft"
        total='1700'
        :barHeight="'234px'"
        title="各区域移栽产量分析"
        :area="Transplantarea"
        :dataArray="TransplantdataArray"
    />
    <cake
        id="`订单统计分析`"
        style="position: absolute; top: 344px; left: 20px"
        title="订单统计分析"
        :data="statisticsData"
        class="animated fadeInLeft"
    />
    <slotCake
        id="`历史平台交易统计分析`"
        style="position: absolute; top: 608px; left: 20px"
        title="历史平台交易统计分析"
        :data="statisticsData"
        class="animated fadeInLeft"
    />
    <HorizontalHistogram
        style="position: absolute; left: 20px; top: 840px"
        class="animated fadeInLeft"
        id="订单商品类型排名"
        title="订单商品类型排名"
        :area="HorizontalArea"
        :dataArray="HorizontalArray"
    />
    <statisticsPanel
        class="animated zoomIn"
        style="
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, 150%);
      "/>
    <threeMap
        @toView="toView"
        class="animated zoomIn"
        style="
        position: absolute;
        left: 50%;
        transform: translate(-50%, 25%);
      "
        v-if="hasGetJson"
        :getJson="getJson"
    ></threeMap>
    <div class="tabsBox AICenter animated fadeInRight" style="position: absolute; right: 20px; top: 98px">
      <div class="tabbotton">
        <div
            :class="[`tab-item`, { cur: index === tabs.index }]"
            :key="item"
            @click="tabs.index = index"
            v-for="(item, index) in tabs.list"
        >
          {{ item }}
        </div>
      </div>
    </div>
    <weatherForecast
        id="当年平台订单总量月同比"
        :lineName="yearName"
        style="position: absolute; right: 20px; top: 150px"
        class="animated fadeInRight"
        title="当年平台订单总量月同比"
        :area="trendarea"
        :dataArray="trendDataArray"
    ></weatherForecast>
    <ComplexHistograms
        id="当年平台订单总量月环比"
        style="position: absolute; right: 20px; top: 378px"
        :barHeight="'216px'"
        class="animated fadeInRight"
        title="当年平台订单总量月环比"
    >
    </ComplexHistograms>
    <weatherForecast
        id="总交易趋势"
        :lineName="yearName"
        style="position: absolute; right: 20px; top: 606px"
        class="animated fadeInRight"
        title="系统当年平台订单总交易趋势(月)"
        :area="Weatherarea"
        :dataArray="WeatherdataArray"
    ></weatherForecast>
    <ComplexHistograms
        id="系统去年平台订单总交易趋势"
        style="position: absolute; right: 20px; top: 834px"
        :barHeight="'225px'"
        class="animated fadeInRight"
        title="系统去年平台订单总交易趋势(月)"
    >
    </ComplexHistograms>
  </bgBox>
</template>

<script>
import mapOfTongren from '@/http/mapOfTongren.json'
import bgBox from '@/components/bgBox/index.vue'
import cake from '@/components/Customize/cake'
import slotCake from '@/components/Customize/slotCake'
import histogram from '@/components/Customize/histogram'
import ComplexHistograms from '@/components/Customize/Complex histograms'
import weatherForecast from '@/components/Customize/weatherForecast'
import HorizontalHistogram from '@/components/Customize/HorizontalHistogram'
import statisticsPanel from '@/components/statisticsPanel/index.vue'
import threeMap from '@/components/Customize/map/index'

export default {
  name: `Home`,
  components: {
    histogram,
    slotCake,
    weatherForecast,
    HorizontalHistogram,
    ComplexHistograms,
    statisticsPanel,
    bgBox,
    threeMap,
    cake,
  },
  data() {
    return {
      tabs: {
        index: 0,
        list: [`订单总量`, `订单交易额`],
      },
      max: 100,
      autoVueFnInit: false,
      statisticsData: {
        title: `目标完成率`,
        value: 0,
        acrossList: [
          {name: `年移栽数量`, value: undefined},
          {name: `年移栽面积`, value: undefined},
        ],
        verticalList: [
          {name: `移栽区域数`, value: undefined},
          {name: `烟农数量`, value: undefined},
        ],
      },
      yearName: {
        lastName: `去年`,
        thisName: `今年`,
      },
      TransplantdataArray: [],
      Transplantarea: [],
      Weatherarea: [],
      WeatherdataArray: {
        temperature: [],
        Weather: [],
      },
      wavyLineArea: [],
      wavyLinedataArray: {
        LastYear: [],
        thisYear: [],
      },
      trendarea: [],
      trendDataArray: {
        LastYear: [],
        thisYear: [],
      },
      HorizontalArea: [],
      HorizontalArray: {
        Done: [],
        Percentage: [],
      },
      getJson: {},
      isGetData: false,
      isWeather: false,
      isWavyLine: false,
      isHorizontal: false,
      isTrend: false,
      hasGetJson: false,
      isCake: false,
    }
  },
  computed: {},
  created() {
    this.getJSON()
    // this.$util.autoVueFn(
    //   [
    //     {
    //       time: 1000 * 60,
    //       fn: this.getWeatherForecast,
    //     },
    //     {
    //       time: 1000 * 60,
    //       fn: this.getAnalysisOfTransplantYieldInVariousRegions,
    //     },
    //     {
    //       time: 1000 * 60,
    //       fn: this.getTransplantAreaInEachRegion,
    //     },
    //     {
    //       time: 1000 * 60,
    //       fn: this.getAnalysisOfTransplantingSituation,
    //     },
    //     {
    //       time: 1000 * 60,
    //       fn: this.getStatistics,
    //     },
    //     {
    //       time: 1000 * 60,
    //       fn: this.getTrendAnalysis,
    //     },
    //   ],
    //   {
    //     vm: this,
    //     batEnd() {
    //       this.autoVueFnInit = true
    //     },
    //   }
    // )
  },
  mounted() {
  },
  methods: {
    async toView(code) {
      console.log(code)

      const {id, 区域编码} = (await this.$util.code2base(this, code)) || {}
      this.$router.push({
        path: `/page3`,
        query: {
          id,
          code: 区域编码,
        },
      })
    },
    tabChange(val) {
      if (val === 0) {
        this.$router.push(`/page1`)
      } else if (val === 1) {
        this.$router.push(`/page2`)
      }
      console.log(`val`, val)
    },
    getAnalysisOfTransplantYieldInVariousRegions() {
      return this.$http
          .get(`/api/analysisOfTransplantYieldInVariousRegions`)
          .then((res) => {
            const area = []
            const dataArray = []
            res.forEach((element) => {
              area.push(element.名称.slice(0, 2))
              dataArray.push(element.值)
            })
            this.Transplantarea = area
            this.TransplantdataArray = dataArray
            this.isGetData = true
          })
    },
    getWeatherForecast() {
      return this.$http
          .get(`/api/weatherForecast`, {
            params: {
              districtId: 0,
            },
          })
          .then((res) => {
            const area = []
            const dataArray = {
              temperature: [],
              Weather: [],
            }
            res.forEach((element) => {
              area.push(element.时间)
              dataArray.temperature.push(element.温度)
              dataArray.Weather.push(element.天气)
            })
            this.Weatherarea = area
            this.WeatherdataArray = dataArray
            this.isWeather = true
          })
    },
    getTransplantAreaInEachRegion() {
      return this.$http.get(`/api/transplantAreaInEachRegion`).then((res) => {
        const area = []
        const dataArray = {
          LastYear: [],
          thisYear: [],
        }
        res.forEach((element) => {
          area.push(element.名称.slice(0, 2))
          dataArray.LastYear.push(element.去年)
          dataArray.thisYear.push(element.今年)
        })
        this.wavyLineArea = area
        this.wavyLinedataArray = dataArray
        this.isWavyLine = true
      })
    },
    getAnalysisOfTransplantingSituation() {
      this.$http.get(`/api/analysisOfTransplantingSituation`).then((res) => {
        const area = []
        const dataArray = {
          Done: [],
          Percentage: [],
        }
        const date = res
        date.forEach((element) => {
          area.push(element.名称.slice(0, 2))
          dataArray.Done.push(element.已移载)
          dataArray.Percentage.push(element.比率.toFixed(0))
        })
        this.HorizontalArea = area
        this.HorizontalArray = dataArray
        this.isHorizontal = true
      })
    },
    getStatistics() {
      return this.$http.get(`/api/realTimeStatistics`).then((res) => {
        const obj = this.statisticsData
        // eslint-disable-next-line no-prototype-builtins
        if (res.hasOwnProperty(obj.title)) {
          obj.value = res[obj.title]
        }
        const list1 = this.statisticsData.acrossList
        this.statisticsData.acrossList = list1.map((item) => {
          // eslint-disable-next-line no-prototype-builtins
          if (res.hasOwnProperty(item.name)) {
            return {...item, value: res[item.name]}
          }
          return item
        })
        const list2 = this.statisticsData.verticalList
        this.statisticsData.verticalList = list2.map((item) => {
          // eslint-disable-next-line no-prototype-builtins
          if (res.hasOwnProperty(item.name)) {
            return {...item, value: res[item.name]}
          }
          return item
        })
        this.isCake = true
      })
    },
    getTrendAnalysis() {
      return this.$http.get(`/api/transplantTrendAnalysis`).then((res) => {
        const area = []
        const dataArray = {
          LastYear: [],
          thisYear: [],
        }
        res.forEach((element) => {
          area.push(element.时间)
          dataArray.LastYear.push(element.去年)
          dataArray.thisYear.push(element.今年)
        })
        this.trendarea = area
        this.trendDataArray = dataArray
        this.isTrend = true
      })
    },
    async getJSON() {
      this.getJson = mapOfTongren
      this.hasGetJson = true
    },
  },
}
</script>
<style lang="less">
.tabbotton {
  text-align: center;
  display: flex;
  justify-content: space-between;
  background-image: url('~@/assets/img2/综合总览/编组 9.png');
  background-repeat: no-repeat;
  background-position: center bottom;
  width: 460px;

  .tab-item {
    width: 220px;
    height: 40px;
    line-height: 40px;
    font-family: YouSheBiaoTiHei;
    font-size: 22px;
    color: #bababa;
    text-align: center;
    position: relative;
    cursor: pointer;
    background-image: url("~@/assets/img/rectangle.png");
    background-size: contain;
    background-repeat: no-repeat;
    background-position: center;


    &.cur {
      color: rgba(77, 255, 251, .9);
      background-image: url("~@/assets/img/rectangleing.png");
      background-size: contain;
      background-repeat: no-repeat;
      background-position: center;
    }
  }
}
</style>
